package examen2014_2015_monoclase;

import histogram.*;
import java.util.Locale;

/**
 * Esta clase se da hecha para probar el código generado.
 * 
 * Se realizan cuatro pruebas que podrán pasarse por separado si se comentan a mano las lineas que se quieran anular
 * <code>
 * <br><br>
 * checkOK(datos, basic);<br>
 * checkOK(datos, module);<br>
 * checkERROR(datos, basic);<br>
 * checkERROR(datos, module);<br>
 * </code>
 * 
 */
public class Examen2014_2015 {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        BinCounter[] basic={new BinCounter(BinCounter.Type.BASIC), new BinCounter(BinCounter.Type.BASIC_CUMULATIVE_LR), new BinCounter(BinCounter.Type.BASIC_CUMULATIVE_RL)};
        BinCounter[] module={new BinCounter(BinCounter.Type.MODULE), new BinCounter(BinCounter.Type.MODULE_CUMULATIVE_LR), new BinCounter(BinCounter.Type.MODULE_CUMULATIVE_RL)};
        
        double[] datos=new double[25];
        for (int i=0;i<datos.length;i++) datos[i]=2*Math.random()-0.5;
        for (int i=0;i<datos.length;i++) System.out.printf("%.2f%c",datos[i],((i+1)%5==0?'\n':'\t'));
        
        checkOK(datos, basic);
        checkOK(datos, module);
        checkERROR(datos, basic);
        checkERROR(datos, module);
    }
 
    
    static void checkOK(double[] datos, BinCounter[] binCounters) {
        double[] bins;
        if (binCounters[0].getType() == BinCounter.Type.BASIC) bins = new double[]{-.1,.1,.2,.3,.4,.5};
        else bins = new double[]{.1,.2,.3,.4,.5};
        for (BinCounter bc:binCounters) {
            bc.calculateBinCounts(bins, datos);
            
            System.out.println(bc.getType());
            System.out.println(bc.countsToText());
            System.out.println(bc.freqsToText());
            System.out.println("--------------------------");
        }
    }

      static void checkERROR(double[] datos, BinCounter[] binCounters){
        double[] bins={-.1,-.1,.2,.3,.4,.5};
        for (BinCounter bc:binCounters) {
            try {
            bc.calculateBinCounts(bins, datos);
            System.out.println(bc.getType()+" debería generar una excepción y no lo hace. (los bins no están ordenados)" );
            } catch (Exception ex) {
                System.out.println(bc.getType()+" genera correctamente una excepción. Mensaje: "+ex.getMessage());
            }
        }
        if (binCounters[0].getType() == BinCounter.Type.BASIC) return;
        bins=new double[]{-.1,.2,.3,.4,.5};
        for (BinCounter bc:binCounters) {
            try {
            bc.calculateBinCounts(bins, datos);
            System.out.println(bc.getType()+" debería generar una excepción y no lo hace. (se le ha dado un bin negativo)" );
            } catch (Exception ex) {
                System.out.println(bc.getType()+" genera correctamente una excepción. Mensaje: "+ex.getMessage());
            }
        }
    }
}
